/*  inventory.h  */
/* All the classes are declared here */
#include <stdio.h>
#include <string.h>
char *strdup(char *s);

class Item {
private:
    char *stockNo;
    char *name;
    double price;
    int inStock;
    static double totalValue;
public:
    Item(char *sNo, char *n, double p, int q);
    Item(char *sNo, char *n);
    char *getStockNo() {return stockNo;};
    char *getName() {return name;};
    double getPrice() {return price;};
    int getInStock() {return inStock;};
    void addStock(int n);
    void removeStock(int n);
    void setPrice(double p);
    virtual void print();
    static double getTotalValue(){return totalValue;};
};

class Book: public Item {
private:
    char *publisher;
    char *author;
    static double totalValue;
public:
    Book(char *stockNo, char *name, char *publisher,
        char *author, double price, int count);
    Book(char *stockNo, char *name, char *publisher,
        char *author);
    char *getPublisher(){return publisher;};
    char *getAuthor(){return publisher;};
    void addStock(int n);
    void removeStock(int n);
    void setPrice(double p);
    void print();
   static double getTotalValue() {return totalValue;};
};

class Software: public Item {
private:
    char *publisher;
    char *version;
    static double totalValue;
public:
    Software(char *stockNo, char *name, char *publisher,
        char *version, double price, int count);
    Software(char *stockNo, char *name, char *publisher,
        char *version);
    char *getPublisher(){return publisher;};
    char *getVersion(){return version;};
    void addStock(int n);
    void removeStock(int n);
    void setPrice(double p);
    void print();
    static double getTotalValue() {return totalValue;};
};

