
/* item.cpp */
/* The item super class used in an inventory-tracking program */

/* Author: Zach Tomaszewski */
/* Date: 19 Mar 2003 */


#include "inventory.h"
#include <iostream>

double Item::totalValue;  //total value of all Items.


// -------- Constructors -----------

/*
 Item constructor.
 Takes a stock number, a string name, a price, 
   and a quanity in stock.
*/
Item::Item(char *sNo, char *n, double p, int q){
    stockNo = sNo;
    name = n;
    price = p;
    inStock = q;
    totalValue += price * inStock;
}

/*
 Item constructor.
 Takes only a stock number and a string name.
*/
Item::Item(char *sNo, char *n){
    stockNo = sNo;
    name = n;
}


// --------- Methods -------

/*
 Takes the number of this Item to add to stock.
 Updates total price.
*/
void Item::addStock(int n){
  inStock += n;
  totalValue += (n * price);
}

/*
 Takes the number of this Item to remove from stock.
 Updates total price.
*/
void Item::removeStock(int n){
  inStock -= n;
  totalValue -= (n * getPrice());
}


/*
 Takes the new price for this Item.
 Updates the price as well as totalValue for all Items.
*/
void Item::setPrice(double p){
  //before starting, remove the old price from totalValue
  totalValue -= (getInStock() * getPrice());
  price = p;
  totalValue += (getInStock() * getPrice());
}


/*
 Prints the Item to the screen
*/
void Item::print(){
  cout << getStockNo() << "  " << getName();
  cout << "  \tPrice: $" << getPrice();
  cout << "\t" << getInStock() << " in stock\n";
}

